
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 450
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_ARB_shader_draw_parameters : require
#extension GL_ARB_shader_ballot : require

out float gl_ClipDistance[1];

invariant gl_Position;

struct S_MATRICES
{
    mat4 _mModelViewProj;
    mat4 _mModelViewProjPrevious;
    mat4 _mModelView;
    mat4 _mInvModelView;
};

struct unaligned_float3
{
    float x;
    float y;
    float z;
};

struct S_TBN
{
    int _iNormal;
    int _iTangent;
};

struct S_INDICES
{
    uint _uiObjectIndex;
    uint _uiMaterialIndex;
    uint _uiMaterialInstanceIndex;
    uint _uiLastFrameMaterialIndex;
    uint _uiLastFrameMaterialInstanceIndex;
    uint _uiPositionsBufferIndex;
    uint _uiPrevPositionsBufferIndex;
    uint _uiNormalsBufferIndex;
    uint _uiPositionOffset;
    uint _uiPrevPositionOffset;
    uint _uiNormalOffset;
    uint _uiMatricesIndex;
};

struct S_MAIN_DEFAULT
{
    S_INDICES _Indices;
};

struct S_MAIN_DEFAULT_ARRAY
{
    S_MAIN_DEFAULT _aMain[32];
};

struct S_MESH_OBJECT
{
    mat4 _mModel;
    mat4 _mModelLast;
    mat4 _mInvModel;
    mat4 _mInvModelLast;
    vec4 _vDiversityOffset;
    uint _uiSceneZoneIndex;
    uint _uiNeighborSceneZoneIndex;
    uint _uiDisplayFlags;
    uint _uiPackedLocalExposureCompensation;
    vec4 _vPortalDirAndDistance;
    int _iPickingID[2];
    float _fLocalExposureCompensation;
    float _fLocalExposureCompensationEV100;
};

struct S_MATERIAL
{
    vec4 _vErrorColor;
    float _fDepthBias;
    float _fDummy0;
    float _fDummy1;
    float _fDummy2;
    float c0;
    float c1;
    float c2;
    float c3;
    uint s0;
    uint s1;
    uint s2;
    uint s3;
    uint s4;
    uint s5;
    uint s6;
    uint s7;
    uint s8;
    uint s9;
    uint s10;
    uint s11;
};

struct S_MATERIAL_INSTANCE
{
    float c0;
    float c1;
    float c2;
    float c3;
    float c4;
    float c5;
    float c6;
    float c7;
    float _fGloubiboulga;
};

struct S_PASS_MATRICES
{
    mat4 _mViewJitteredProj;
    mat4 _mViewProj;
    mat4 _mView;
    mat4 _mInvView;
    mat4 _mJitteredProj;
};

struct S_EYE_DATA
{
    S_PASS_MATRICES _mCurrentFrameMatrices[2];
    S_PASS_MATRICES _mPreviousFrameMatrices[2];
    mat4 _mJitteredProjection[2];
    mat4 _mNoJitterProjection[2];
    mat4 _mInvViewJitteredProj[2];
    vec4 _vWorldSpaceCameraVector[2];
    vec4 _vWorldSpaceCameraPosition[2];
    vec4 _vFrameBufferScale;
    vec4 _vFrameBufferViewportSize;
    vec4 _vFrameBufferOneOnViewportSize;
    vec4 _vViewportSize;
    vec4 _vFogSubCrop;
    uint _uiAlignment0;
    uint _uiAlignment1;
    float _vCameraJitterDeltaX;
    float _vCameraJitterDeltaY;
    vec4 _vfRcpFVolumetricFogDepthTileSize;
};

struct S_CASCADED_SHADOW
{
    mat4 _mCascadeMatrix[2][8];
    mat4 _mViewSpaceToStaticShadowMapSpace[2];
    vec4 _vfCascadeShadowAttenuation;
    vec4 _vfShadowCascadeTextureTexelSize;
    vec4 _vfStaticShadowBlurRadius;
    vec4 _vfCascadeLinearZProjFactors[8];
    vec4 _vfCascadeParams[8];
};

struct S_CLUSTER_LIGHT_SETUP
{
    S_CASCADED_SHADOW _CascadedShadow;
    vec4 _vfSkinUVParamsAndNormalBias;
    vec4 _vfShadowTextureTexelSize;
    vec4 _vfDummy_SkinFresnelF0AndF90;
    uint _uiCascadedUsed;
    float _fSSSWidth;
    float _fOffsetBias;
    float _fDummy;
};

struct S_CLUSTER_INFO
{
    mat4 _mViewToClusterView[2];
    mat4 _mClusterProjMatrix;
    mat4 _mClusterInvProjMatrix;
    vec4 _vfLeftEyeToCombinedEyeVsDeltaXZ;
    uint _uiFinestMipWidth;
    uint _uiFinestMipHeight;
    uint _uiFinestMipDepth;
    uint _uiFinestMipWidthHeight;
    float _fZSliceGeomFactor;
    float _fRcpLogZSliceGeomFactor;
    float _fDummy0;
    float _fDummy1;
    float _fNearP;
    float _fInvNearP;
    float _fFarP;
    float _fClusterCoincidentWithCamera;
};

struct S_PASS
{
    S_EYE_DATA _EyeData;
    vec4 _avFrustumCorners[4];
    vec4 _vTime;
    vec4 _cFogColor;
    vec4 _vFogSetup;
    vec4 _cSunColor;
    vec4 _vSunDir;
    vec4 _vProjectionSetup;
    vec4 _vProjectionCoeff;
    vec4 _vOutputColor;
    vec4 _vfVsClippingPlane[2];
    S_CLUSTER_LIGHT_SETUP _LightSetup;
    S_CLUSTER_INFO _ClusterInfo;
    float _fIBLIntensity;
    float _fGIIntensity;
    float _fAmbiantOcclusionDirectIntensity;
    float _fAmbiantOcclusionIndirectIntensity;
    float _fNormalSign;
    int _iFogType;
    float _fSelfOcclusionDebugRatio;
    float _fEmissive;
    int _iEnableSkinSSSSS;
    int _iUseHairOpaquePrepass;
    float _fLocalSceneExposure;
    uint _uiDebugMode;
    uint _sFlags;
    float _fTAADropsSharpness;
    uint _uNeoScaleX;
    uint _uNeoScaleY;
    uint _uiDirectOverdrawFilter;
    float _fCoderTest0;
    float _fCoderTest1;
    float _fCoderTest2;
    uint _uiBakeOutput;
    float _fDefaultAmbientIntensity;
    float _fDefaultLightingIntensity;
    uint _uiOutputColor;
    float _fAARotation;
    float _fClampDirectSpecular;
    float _fNearPlane;
    float _fFarPlane;
    float _fNDFFilteringScreenSpaceVariance;
    float _fNDFFilteringThreshold;
    float _fNDFFilteringScreenSpaceVariance_EyeShader;
    float _fNDFFilteringThreshold_EyeShader;
    float _fSurfaceGradientTextureFiltering;
    float _fZero;
    uint _uDepthClamp;
    uint _uiLightDebugMode;
    vec4 _vfFragCoordToDepthTexFactor;
    vec4 _vfFragCoordToDepthTexFactor_HalfRes;
    uint _uHdr;
    uint _uiDrawMayaSwatch;
    float _fEyeRoughnessBias;
    float _fDummy1;
};

layout(set = 1, binding = 24, std430) readonly buffer stc_g_rbMatrices_Layout
{
    S_MATRICES g_rbMatrices[];
} _165;

layout(set = 1, binding = 39, std430) readonly buffer g_rbVertices_Layout
{
    unaligned_float3 g_rbVertices[];
} g_rbVertices_Buffer[];

layout(set = 1, binding = 40, std430) readonly buffer g_rbTBNs_Layout
{
    S_TBN g_rbTBNs[];
} g_rbTBNs_Buffer[];

layout(set = 0, binding = 52, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_MAIN_ARRAY_BINDING
{
    S_MAIN_DEFAULT_ARRAY g_cbMainArray;
} _1120;

layout(set = 1, binding = 33, std430) readonly buffer g_rbObjects_Layout
{
    S_MESH_OBJECT g_rbObjects[];
} g_rbObjects_Buffer[];

layout(set = 1, binding = 34, std430) readonly buffer g_rbMaterials_Layout
{
    S_MATERIAL g_rbMaterials[];
} g_rbMaterials_Buffer[];

layout(set = 1, binding = 35, std430) readonly buffer g_rbMaterialInstances_Layout
{
    S_MATERIAL_INSTANCE g_rbMaterialInstances[];
} g_rbMaterialInstances_Buffer[];

layout(set = 2, binding = 53, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_PASS_BINDING
{
    S_PASS g_cbPass;
} _1381;

layout(set = 1, binding = 12) uniform sampler2D g_rb2DTextures[];

layout(location = 8) in vec2 in_uv0;
layout(location = 23) out float interp_instanceID;

vec3 _7967;

void main()
{
    int _1110 = gl_InstanceIndex + gl_DrawIDARB;
    int _1111 = readFirstInvocationARB(_1110);
    uint _3047 = uint(gl_VertexIndex);
    uint _3050 = _3047 + _1120.g_cbMainArray._aMain[_1111]._Indices._uiPositionOffset;
    vec4 _3063 = vec4(g_rbVertices_Buffer[_1120.g_cbMainArray._aMain[_1111]._Indices._uiPositionsBufferIndex].g_rbVertices[_3050].x, g_rbVertices_Buffer[_1120.g_cbMainArray._aMain[_1111]._Indices._uiPositionsBufferIndex].g_rbVertices[_3050].y, g_rbVertices_Buffer[_1120.g_cbMainArray._aMain[_1111]._Indices._uiPositionsBufferIndex].g_rbVertices[_3050].z, 1.0);
    uint _3070 = _3047 + _1120.g_cbMainArray._aMain[_1111]._Indices._uiNormalOffset;
    int _3099 = g_rbTBNs_Buffer[_1120.g_cbMainArray._aMain[_1111]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3070]._iNormal & 1023;
    int _3102 = (g_rbTBNs_Buffer[_1120.g_cbMainArray._aMain[_1111]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3070]._iNormal >> 10) & 1023;
    int _3105 = (g_rbTBNs_Buffer[_1120.g_cbMainArray._aMain[_1111]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3070]._iNormal >> 20) & 1023;
    int _7954;
    if (_3099 > 512)
    {
        _7954 = _3099 | (-1024);
    }
    else
    {
        _7954 = _3099;
    }
    int _7956;
    if (_3102 > 512)
    {
        _7956 = _3102 | (-1024);
    }
    else
    {
        _7956 = _3102;
    }
    int _7958;
    if (_3105 > 512)
    {
        _7958 = _3105 | (-1024);
    }
    else
    {
        _7958 = _3105;
    }
    float _3148 = float(_7954);
    float _3151 = float(_7956);
    float _3154 = float(_7958);
    vec3 _3155 = vec3(_3148, _3151, _3154);
    vec3 _3158 = _3155 * vec3(0.001956947147846221923828125);
    vec3 _3248 = _3063.xyz;
    mat3 _3440 = mat3(g_rbObjects_Buffer[_1120.g_cbMainArray._aMain[_1111]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[0].xyz, g_rbObjects_Buffer[_1120.g_cbMainArray._aMain[_1111]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[1].xyz, g_rbObjects_Buffer[_1120.g_cbMainArray._aMain[_1111]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[2].xyz);
    vec3 _3443 = _3440 * _3158;
    vec2 _3650 = in_uv0 * vec2(2.0);
    vec3 _7900 = _7967;
    _7900.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1120.g_cbMainArray._aMain[_1111]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], _3650 + vec2(-1.10000002384185791015625, -0.5714290142059326171875), 0.0).x;
    vec3 _3668 = vec3(g_rbMaterialInstances_Buffer[_1120.g_cbMainArray._aMain[_1111]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c0);
    vec3 _3671 = mod(_3668, vec3(2.0));
    vec3 _3675 = _7900 * _3671;
    vec3 _7909 = _7967;
    _7909.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1120.g_cbMainArray._aMain[_1111]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], _3650 + vec2(-0.8979589939117431640625, 0.190476000308990478515625), 0.0).y;
    vec3 _3705 = _3668 * vec3(0.100000001490116119384765625);
    vec3 _3708 = floor(_3705);
    vec3 _3712 = mod(_3708, vec3(2.0));
    vec3 _3716 = _7909 * _3712;
    vec3 _3720 = vec3(1.0) - _3675;
    vec3 _3723 = vec3(1.0) - _3716;
    vec3 _3724 = _3720 * _3723;
    vec3 _7918 = _7967;
    _7918.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1120.g_cbMainArray._aMain[_1111]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], in_uv0 + vec2(0.20000000298023223876953125, 0.0816330015659332275390625), 0.0).z;
    vec3 _3756 = _3668 * vec3(0.00999999977648258209228515625);
    vec3 _3759 = floor(_3756);
    vec3 _3763 = mod(_3759, vec3(2.0));
    vec3 _3767 = _7918 * _3763;
    vec3 _3774 = vec3(1.0) - _3767;
    vec3 _3775 = _3724 * _3774;
    vec3 _3777 = vec3(1.0) - _3775;
    float _3779 = _3777.y;
    float _3784 = _3779 - 0.949999988079071044921875;
    float _3789 = _3784 * 19.9959964752197265625;
    float _3790 = clamp(_3789, 0.0, 1.0);
    float _3791 = mix(0.0, 1.0, _3790);
    float _3799 = _3779 - 0.88999998569488525390625;
    float _3804 = _3799 * 99.90019989013671875;
    float _3805 = clamp(_3804, 0.0, 1.0);
    float _3806 = mix(0.0, 1.0, _3805);
    vec3 _3811 = vec3(_3806);
    vec3 _3812 = mix(vec3(0.0), vec3(-0.011610000394284725189208984375), _3811);
    vec3 _3817 = vec3(_3791);
    vec3 _3818 = mix(_3812, vec3(-0.03869999945163726806640625), _3817);
    vec3 _3824 = _3818 * _3443;
    vec3 _3832 = vec3(g_rbMaterialInstances_Buffer[_1120.g_cbMainArray._aMain[_1111]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c1);
    vec3 _3833 = mix(vec3(0.0), _3824, _3832);
    vec3 _3857 = _3248 + _3833;
    float _3983 = _3857.x;
    float _3984 = _3857.y;
    float _3985 = _3857.z;
    vec4 _3986 = vec4(_3983, _3984, _3985, 1.0);
    vec4 _3987 = _165.g_rbMatrices[_1120.g_cbMainArray._aMain[_1111]._Indices._uiMatricesIndex]._mModelView * _3986;
    vec4 _4006 = _165.g_rbMatrices[_1120.g_cbMainArray._aMain[_1111]._Indices._uiMatricesIndex]._mModelViewProj * _3986;
    vec4 _7964;
    if (_1381.g_cbPass._uDepthClamp == 4294967295u)
    {
        float _4040 = _4006.w;
        vec4 _7965;
        if ((_4006.z / _4040) > 1.0)
        {
            vec4 _7966;
            if (_3987.z > _1381.g_cbPass._fNearPlane)
            {
                vec4 _7931 = _4006;
                _7931.z = _4040;
                _7966 = _7931;
            }
            else
            {
                _7966 = _4006;
            }
            _7965 = _7966;
        }
        else
        {
            _7965 = _4006;
        }
        _7964 = _7965;
    }
    else
    {
        _7964 = _4006;
    }
    interp_instanceID = float(_1110) + 0.5;
    float _2933 = _3987.x;
    float _2934 = _3987.y;
    float _2935 = _3987.z;
    vec4 _2936 = vec4(_2933, _2934, _2935, 1.0);
    float _2937 = dot(_1381.g_cbPass._vfVsClippingPlane[0], _2936);
    float _2938 = -_2937;
    gl_ClipDistance[0] = _2938;
    gl_Position = _7964;
}

